std::erase,std::erase_if(std::deque)(3)

NAME
std::erase,std::erase_if(std::deque) - std::erase,std::erase_if(std::deque)

Synopsis
   Defined in header <deque>
   template< class T, class Alloc, class U >
   typename std::deque<T,Alloc>::size_type (1) (since C++20)
   erase( std::deque<T,Alloc>& c, const U& value );
   template< class T, class Alloc, class Pred >
   typename std::deque<T,Alloc>::size_type (2) (since C++20)
   erase_if( std::deque<T,Alloc>& c, Pred pred );
   1) Erases all elements that compare equal to value from the container. Equivalent to
 auto it = std::remove(c.begin(), c.end(), value);
 auto r = std::distance(it, c.end());
 c.erase(it, c.end());
 return r;
   2) Erases all elements that satisfy the predicate pred from the container.
   Equivalent to
 auto it = std::remove_if(c.begin(), c.end(), pred);
 auto r = std::distance(it, c.end());
 c.erase(it, c.end());
 return r;

Parameters
   c - container from which to erase
   value - value to be removed
           unary predicate which returns true if the element should be erased.
           The expression pred(v) must be convertible to bool for every argument v of
   pred - type (possibly const) T, regardless of value category, and must not modify
           v. Thus, a parameter type of T&is not allowed
           , nor is T unless for T a move is equivalent to a copy
           (since C++11).

Return value
   The number of erased elements.

Complexity
   Linear.

Example
// Run this code
 #include <iostream>
 #include <numeric>
 #include <string_view>
 #include <deque>
 void print_container(std::string_view comment, const std::deque<char>& c)
 {
     std::cout << comment << "{ ";
     for (auto x : c) {
         std::cout << x << ' ';
     }
     std::cout << "}\n";
 }
 int main()
 {
     std::deque<char> cnt(10);
     std::iota(cnt.begin(), cnt.end(), '0');
     print_container("Initially, cnt = ", cnt);
     std::erase(cnt, '3');
     print_container("After erase '3', cnt = ", cnt);
     auto erased = std::erase_if(cnt, [](char x) { return (x - '0') % 2 == 0; });
     print_container("After erase all even numbers, cnt = ", cnt);
     std::cout << "Erased even numbers: " << erased << '\n';
 }

Output:
 Initially, cnt = { 0 1 2 3 4 5 6 7 8 9 }
 After erase '3', cnt = { 0 1 2 4 5 6 7 8 9 }
 After erase all even numbers, cnt = { 1 5 7 9 }
 Erased even numbers: 5

See also
   remove removes elements satisfying specific criteria
   remove_if (function template)